//-------------------------------------------------------------//
//--------------------- PARSER SCRIPTS ------------------------//
//-------------------------------------------------------------//

//definizionde dell'oggetto CARATTERE
function carattere(index, rif_char) {
    this.index = index;
    this.rif_char = rif_char;
    this.styles = [];
}
//------------------------------------------------------------------------------------------
function parse_free(){
	
	//recupero il testo dall'area di testo dedicata alla stesura di testo in linguaggio markup
	var obj_testo_formatted = [];
	var testo = $("#txt_free_user_code").val();
	testo = testo.trim();

	if (testo ==''){
		alert("ATTENZIONE! Inserire un testo prima di procedere alla formattazione");
		return;
	}

	//parsing del testo
	var array_testo_iniziale = testo.split("");

	//creazione array di oggetti carattere
	
	for(var i=0; i<array_testo_iniziale.length; i++){
		var rif_obj_char = new carattere(i,array_testo_iniziale[i]);
		obj_testo_formatted.push(rif_obj_char);
	}

	if(array_testo_iniziale.length >0){

		//scorro l'array
		for(var i=0; i<array_testo_iniziale.length; i++){
			var start_simbol, end_symbol;
			var rif_char = array_testo_iniziale[i];
			var start_index = i;
			var end_index =-1;//identifica che il carattere non è un simbolo di markup

			//controlla se il carattere è un simbolo di markup e cerca il simbolo di chiusura
			switch(rif_char){
				case "*":
					start_simbol = "*";
					end_simbol = "*";
					end_index = find_next_symbol(end_simbol,i,array_testo_iniziale);
					break;
				case "+":
					start_simbol = "+";
					end_simbol = "+";
					end_index = find_next_symbol(end_simbol,i,array_testo_iniziale);
					break;
				case "&":
					start_simbol = "&";
					end_simbol = "&";
					end_index = find_next_symbol(end_simbol,i,array_testo_iniziale);
					break;
				case "$":
					start_simbol = "$";
					end_simbol = "$";
					end_index = find_next_symbol(end_simbol,i,array_testo_iniziale);
					break;
				case "_":
					start_simbol = "_";
					end_simbol = "_";
					end_index = find_next_symbol(end_simbol,i,array_testo_iniziale);
					break;
			}

			//controlla se è avvenuta una ricerca
			if(end_index!=-1){
				//controlla che non ci siano stati errore di formattazioni es: $*$*
				if(end_index==-2){
					//ricompongo la string di testo, a questo punto formattata, a partire dall'array
					showError(testo, start_index, 'txt_formatted_free','container_persered_text_free');

					alert("ATTENZIONE! Riscontrato un simbolo di formattazione non correttamente chiuso dopo il simbolo \""+start_simbol+"\"");
					log_parse('','Esercitazione libera','',testo,"Riscontrato un simbolo di formattazione non correttamente chiuso dopo il simbolo \""+start_simbol+"\"");
					return;
				}

				//controlla se la ricerca è andata a buon fine
				if(end_index!=null){
					//effettua replace per formattazione
					switch (start_simbol){
						case "*":
							array_testo_iniziale[start_index] = "<strong>";
							array_testo_iniziale[end_index] = "</strong>";
							break;
						case "+":
							array_testo_iniziale[start_index] = "<i>";
							array_testo_iniziale[end_index] = "</i>";
							break;
						case "&":
							array_testo_iniziale[start_index] = "<span style=\"color: red\">";
							array_testo_iniziale[end_index] = "</span>";
							break;
						case "$":
							array_testo_iniziale[start_index] = "<span style=\"background-color: #FFFF00\">";
							array_testo_iniziale[end_index] = "</span>";
							break;
						case "_":
							array_testo_iniziale[start_index] = "<u>";
							array_testo_iniziale[end_index] = "</u>";
							break;
					}

					//aggiungo ad ogni carattere compreso nell'intervallo di formattazione, lo stile applicato all'interno dell'oggetto Carattere
					for(var j=start_index+1; j<end_index; j++){
						if(obj_testo_formatted[j].styles.indexOf(start_simbol) == -1 ){
							obj_testo_formatted[j].styles.push(start_simbol);
						}
					}
				}
				else{
					alert("ATTENZIONE! Il testo inserito presenta degli errori di formattazione: il simbolo \"" +rif_char+ "\" non presenta il corrispettivo per la chiusura.");
					log_parse('',JSON.stringify(obj_testo_rif),'',testo,"Il testo inserito presenta degli errori di formattazione: il simbolo \"" +rif_char+ "\" non presenta il corrispettivo per la chiusura.");
					showError(testo,start_index,'txt_formatted_free','container_persered_text_free');
					return;
				}
			}
		}

		//FORMATTAZIONE TERMINATA CON SUCCESSO

		//ricompongo la string di testo, a questo punto formattata, a partire dall'array
		//var final_text="";
		//$.each(array_testo_iniziale, function(index) {                    
		//	  final_text = final_text + array_testo_iniziale[index];
		//});

		//mostra il testo nell'apposito div
		//$("#txt_formatted_free").html(final_text);
		//$("#container_persered_text_free").show();

		//aggiorno array di oggetti ri muovendo i caratteri speciali
		var index_to_remove = [];
		for(var j=0; j<obj_testo_formatted.length; j++){
			obj_testo_formatted[j].index=j;
			switch (obj_testo_formatted[j].rif_char){
			case "*":
			case "+":
			case "&":
			case "$":
			case "_":
			//case "]":
				index_to_remove.push(obj_testo_formatted[j].index);
				break;
			}
		}
		try{
			for(var k=0;k<index_to_remove.length; k++){
				obj_testo_formatted = _.without(obj_testo_formatted, _.findWhere(obj_testo_formatted, {index: index_to_remove[k]}));
			}
		}
		catch(err){
			var error =err.message;
		}
		
		//ricrea testo formattato
		var html_testo="";
		$.each(obj_testo_formatted, function(index){
			var carattere =  obj_testo_formatted[index];
			if(carattere.styles.length>0){
				html_testo = html_testo + '<span style="';

				//controlla se applicare style grassetto
				if(carattere.styles.indexOf("*") != -1 ){
					html_testo = html_testo + "font-weight: bold; ";
				}
				//controlla se applicare style corsivo
				if(carattere.styles.indexOf("+") != -1 ){
					html_testo = html_testo + "font-style: italic; ";
				}
				//controlla se applicare style colorato
				if(carattere.styles.indexOf("&") != -1 ){
					html_testo = html_testo + "color: red; ";
				}
				//controlla se applicare style sottolineato
				if(carattere.styles.indexOf("_") != -1 ){
					html_testo = html_testo + "text-decoration: underline; ";
				}
				//controlla se applicare style evidenziato
				if(carattere.styles.indexOf("$") != -1 ){
					html_testo = html_testo + "background-color: #FFFF00; ";
				}

				html_testo = html_testo + '">'+unescape(carattere.rif_char)+'</span>';
			}
			else{
				html_testo = html_testo + unescape(carattere.rif_char);
			}
		});

		//mostra il testo nell'apposito div
		$("#txt_formatted_free").html(html_testo);
		$("#container_persered_text_free").show();


		//aggiorno array di oggetti ri muovendo i caratteri speciali
		var index_to_remove = [];
		for(var j=0; j<obj_testo_formatted.length; j++){
			obj_testo_formatted[j].index=j;
			switch (obj_testo_formatted[j].rif_char){
			case "*":
			case "+":
			case "&":
			case "$":
			case "_":
			//case "]":
				index_to_remove.push(obj_testo_formatted[j].index);
				break;
			}
		}
		try{
			for(var k=0;k<index_to_remove.length; k++){
				obj_testo_formatted = _.without(obj_testo_formatted, _.findWhere(obj_testo_formatted, {index: index_to_remove[k]}));
			}
		}
		catch(err){
			var error =err.message;
		}
	}
}
//------------------------------------------------------------------------------------------
function parse(id_testo){

	var enable_parse = $("#btn_parser").attr("enable_parse");

	//controlla che sia abilitata la funzione di parsing -> deve essere stato selezionato un testo di riferimento
	if(enable_parse!="1"){
		alert("ATTENZIONE! Selezionare un testo di riferimento prima di procedere alla formattazione del testo.");
		log_parse('','','',testo,"Nessun testo di riferimento selezionato");
		return;
	}

	$("#txt_formatted").html('');
	//recupero il testo dall'area di testo dedicata alla stesura di testo in linguaggio markup
	var testo = $("#txt_user_code").val();
	var obj_testo_rif=[];
	var obj_testo_formatted = [];
	
	//Controlla che sia stato inserito del testo
	if(testo!=''){
		//elimina gli spazi all'inizio e alla fine della frase
		testo = testo.trim();

		//recupera il json dei testi di riferimento
    json = $.parseJSON(document.getElementById('sampletext').innerHTML);
		    if(json.length >0){
		    	var obj_ref=null;

		    	for(var i=0; i<json.length ;i++){
		    		if(json[i].id==id_testo){
						obj_ref = json[i];
		    		}
		    	}

		    	//crea la struttura javascript a patire dal JSON appena letto
		    	if(obj_ref!=null){
		    		for(var j=0; j<obj_ref.objectChars.length; j++){
		    			var JSON_char = obj_ref.objectChars[j];
		    			var car="";

		    			try{
		    				car = unescape(JSON_char.obj_char);
		    			}
		    			catch(err){
		    				var e = err.message;
		    			}


		    			var new_char = new carattere(j,car);

		    			//controlla che il carattere sia stato correttamente creato
		    			if(new_char!= null && new_char != 'undefined' && new_char!= undefined && new_char!=''){
		    				//applico al carattere gli stili
		    				for(var k=0; k<JSON_char.styles.length; k++){
		    					new_char.styles.push(JSON_char.styles[k]);
		    				}

		    				obj_testo_rif.push(new_char);
		    			}
		    		}
		    	}
		    	else{
		    		alert("ATTENZIONE! Riscontrato un simbolo di formattazione non correttamente chiuso dopo il simbolo \""+start_simbol+"\"");
					log_parse('','','','',"Imppssibile recuperare il testo di riferimento");
					return;
		    	}
		    	//inserisco testo all'interno di un array
				var array_testo_iniziale = testo.split("");

				//creazione array di oggetti carattere
				for(var i=0; i<array_testo_iniziale.length; i++){
					var rif_obj_char = new carattere(i,array_testo_iniziale[i]);
					obj_testo_formatted.push(rif_obj_char);
				}

				if(array_testo_iniziale.length >0){

					//scorro l'array
					for(var i=0; i<array_testo_iniziale.length; i++){
						var start_simbol, end_symbol;
						var rif_char = array_testo_iniziale[i];
						var start_index = i;
						var end_index =-1;//identifica che il carattere non è un simbolo di markup

						//controlla se il carattere è un simbolo di markup e cerca il simbolo di chiusura
						switch(rif_char){
							case "*":
								start_simbol = "*";
								end_simbol = "*";
								end_index = find_next_symbol(end_simbol,i,array_testo_iniziale);
								break;
							case "+":
								start_simbol = "+";
								end_simbol = "+";
								end_index = find_next_symbol(end_simbol,i,array_testo_iniziale);
								break;
							case "&":
								start_simbol = "&";
								end_simbol = "&";
								end_index = find_next_symbol(end_simbol,i,array_testo_iniziale);
								break;
							case "$":
								start_simbol = "$";
								end_simbol = "$";
								end_index = find_next_symbol(end_simbol,i,array_testo_iniziale);
								break;
							case "_":
								start_simbol = "_";
								end_simbol = "_";
								end_index = find_next_symbol(end_simbol,i,array_testo_iniziale);
								break;
						}

						//controlla se è avvenuta una ricerca
						if(end_index!=-1){
							//controlla che non ci siano stati errore di formattazioni es: $*$*
							if(end_index==-2){
								//ricompongo la string di testo, a questo punto formattata, a partire dall'array
								showError(testo, start_index,'txt_formatted','container_persered_text');

								alert("ATTENZIONE! Riscontrato un simbolo di formattazione non correttamente chiuso dopo il simbolo \""+start_simbol+"\"");
								log_parse('',JSON.stringify(obj_testo_rif),'',testo,"Riscontrato un simbolo di formattazione non correttamente chiuso dopo il simbolo \""+start_simbol+"\"");
								return;
							}

							//controlla se la ricerca è andata a buon fine
							if(end_index!=null){
								//effettua replace per formattazione
								switch (start_simbol){
									case "*":
										array_testo_iniziale[start_index] = "<strong>";
										array_testo_iniziale[end_index] = "</strong>";
										break;
									case "+":
										array_testo_iniziale[start_index] = "<i>";
										array_testo_iniziale[end_index] = "</i>";
										break;
									case "&":
										array_testo_iniziale[start_index] = "<span style=\"color: red\">";
										array_testo_iniziale[end_index] = "</span>";
										break;
									case "$":
										array_testo_iniziale[start_index] = "<span style=\"background-color: #FFFF00\">";
										array_testo_iniziale[end_index] = "</span>";
										break;
									case "_":
										array_testo_iniziale[start_index] = "<u>";
										array_testo_iniziale[end_index] = "</u>";
										break;
								}

								//aggiungo ad ogni carattere compreso nell'intervallo di formattazione, lo stile applicato all'interno dell'oggetto Carattere
								for(var j=start_index+1; j<end_index; j++){
									if(obj_testo_formatted[j].styles.indexOf(start_simbol) == -1 ){
										obj_testo_formatted[j].styles.push(start_simbol);
									}
								}
							}
							else{
								alert("ATTENZIONE! Il testo inserito presenta degli errori di formattazione: il simbolo \"" +rif_char+ "\" non presenta il corrispettivo per la chiusura.");
								log_parse('',JSON.stringify(obj_testo_rif),'',testo,"Il testo inserito presenta degli errori di formattazione: il simbolo \"" +rif_char+ "\" non presenta il corrispettivo per la chiusura.");
								showError(testo,start_index,'txt_formatted','container_persered_text');
								return;
							}
						}
					}

					//FORMATTAZIONE TERMINATA CON SUCCESSO

					//ricompongo la string di testo, a questo punto formattata, a partire dall'array
					//var final_text="";
					//$.each(array_testo_iniziale, function(index) {                    
					//	  final_text = final_text + array_testo_iniziale[index];
					//});

					//mostra il testo nell'apposito div
					//$("#txt_formatted").html(final_text);
					//$("#container_persered_text").show();

					//aggiorno array di oggetti ri muovendo i caratteri speciali
					var index_to_remove = [];
					for(var j=0; j<obj_testo_formatted.length; j++){
						obj_testo_formatted[j].index=j;
						switch (obj_testo_formatted[j].rif_char){
						case "*":
						case "+":
						case "&":
						case "$":
						case "_":
						//case "]":
							index_to_remove.push(obj_testo_formatted[j].index);
							break;
						}
					}
					try{
						for(var k=0;k<index_to_remove.length; k++){
							obj_testo_formatted = _.without(obj_testo_formatted, _.findWhere(obj_testo_formatted, {index: index_to_remove[k]}));
						}
					}
					catch(err){
						var error =err.message;
					}

					//ricrea HTML del testo formattato
					var html_testo="";
					$.each(obj_testo_formatted, function(index){
						var carattere =  obj_testo_formatted[index];
	    				if(carattere.styles.length>0){
	    					html_testo = html_testo + '<span style="';

	    					//controlla se applicare style grassetto
	    					if(carattere.styles.indexOf("*") != -1 ){
								html_testo = html_testo + "font-weight: bold; ";
							}
							//controlla se applicare style corsivo
	    					if(carattere.styles.indexOf("+") != -1 ){
								html_testo = html_testo + "font-style: italic; ";
							}
							//controlla se applicare style colorato
	    					if(carattere.styles.indexOf("&") != -1 ){
								html_testo = html_testo + "color: red; ";
							}
							//controlla se applicare style sottolineato
	    					if(carattere.styles.indexOf("_") != -1 ){
								html_testo = html_testo + "text-decoration: underline; ";
							}
							//controlla se applicare style evidenziato
	    					if(carattere.styles.indexOf("$") != -1 ){
								html_testo = html_testo + "background-color: #FFFF00; ";
							}

	    					html_testo = html_testo + '">'+unescape(carattere.rif_char)+'</span>';
	    				}
	    				else{
	    					html_testo = html_testo + unescape(carattere.rif_char);
	    				}
					});

					//mostra il testo nell'apposito div
					$("#txt_formatted").html(html_testo);
					$("#container_persered_text").show();
					

					//MATCHING TRA TESTO RIFERIMENTO E RISULTATO FORMATTAZIONE
					var matching_result=match(obj_testo_rif, obj_testo_formatted);

					//condizione per il colore del testo nella modal in base alla percentuale di matching
					if(matching_result[1] >=100){
						$("#percentuale_form").css("color","#4dff4d");
					}
					else{
						if(matching_result[1] >=60){
							$("#percentuale_form").css("color","#ffdb4d");
						}
						else{
							$("#percentuale_form").css("color","#ff6666");
						}
					}

					$("#percentuale_form").html(matching_result[1]);
					$("#modalMatching").modal('show');

					//log del risultato del parser
					log_parse(matching_result[1],JSON.stringify(obj_testo_rif),JSON.stringify(obj_testo_formatted),testo,'');

					return matching_result;
				}
				else{
					alert("ATTENZIONE! Il testo inserito non è valido");
					log_parse('',JSON.stringify(obj_testo_rif),'',testo,'Il testo inserito dall\'utente non è valido');
					return;
				}
			}
	}
	else{
		alert("ATTENZIONE! Prima di effettuare la formattazione, inserire il testo formattato nell'apposita area di testo");
		log_parse('',JSON.stringify(obj_testo_rif),'','','nessun testo inserito dall\'utente');
		return;
	}
}
//------------------------------------------------------------------------------------------
function find_next_symbol(simbol_rif, start_index, array_text){
	var end_index = null;
	var simbol_counter=0;

	for(var i=start_index+1; i<array_text.length;i++){

		
		if(array_text[i] == simbol_rif){
			//controlla che il tag di chiusura non sia preceduto da altri simboli di markup, altri restituisce errore
			if(simbol_counter%2!=0){
				return -2;
			}
			else{
				return i;	
			}
			
		}
		else{
			switch (array_text[i]){
				case "*":						
				case "+":						
				case "&":							
				case "$":
				case "_":
				//case "[":
					simbol_counter ++;;
					break;
			}
		}
	}
	return end_index;
}
//------------------------------------------------------------------------------------------
function showError(testo, start_index,id_txt_formatted, id_container){

	var array_testo_iniziale = testo.split("");
	array_testo_iniziale[start_index] = "<span style=\"background-color: #FF5656\">"+array_testo_iniziale[start_index]+"</span>"
	var final_text="";
	$.each(array_testo_iniziale, function(index) {                    
		  final_text = final_text + array_testo_iniziale[index];
	});

	//mostra il testo nell'apposito div
	$("#"+id_txt_formatted).html(final_text);
	$("#"+id_container).show();
}
//------------------------------------------------------------------------------------------
function match(rif, formatted){
	var result=[];
	var hit=0;
	var error=[];

	try {
	    if(rif.length === formatted.length){
			//procede al matching char 2 char
			for(var i=0; i<rif.length; i++){
				//controlla uguaglianze carattere
				if(rif[i].rif_char === formatted[i].rif_char){
					//CONTROLLO SUGLI STYLE DEL CARATTERE 'spazio'
					//devono essere presi in considerazione solo ggli stile 'sottolineato' ed 'evidenziato' --> gli altri vengono esclusi dal confronto
					if(formatted[i].rif_char==' '){
						formatted[i].styles = _.without(formatted[i].styles, '+', '*','&');	
						rif[i].styles = _.without(rif[i].styles, '+', '*','&');	
					}

					//Controllo sullo stile
					if(rif[i].styles.length ==formatted[i].styles.length){

						var difference = _.difference(rif[i].styles,formatted[i].styles);
						if(_.isEmpty(difference) ){
							hit++;
						}
						else{
							if($.inArray('Le due frasi hanno formattazione differente', error) <0){
								error.push('Le due frasi hanno formattazione differente');
							}	
						}
					}
					else{
						if($.inArray('Le due frasi hanno formattazione differente', error) <0){
							error.push('Le due frasi hanno formattazione differente');
						}
					}
				}
				else{
					if($.inArray("Le due frasi sono diverse", error) <0){
							error.push('Le due frasi hanno formattazione differente');
						}
				}
			}
		}else{
			error.push("Le due frasi sono diverse: lunghezza testo riferimento: "+rif.length+" caratteri, lunghezza testo formattato: "+formatted.length+" caratteri")
		}

		result.push(error);
		var hit_success = 0;
		if(hit>0){
			hit_success=(hit/rif.length)*100;
		}
		result.push(parseFloat(hit_success).toFixed(2));

		return result;
	}
	catch(err) {
	    alert(err.message);
	}
}
//---------------------------------------------------------------------------------------------
function log_parse(parsing_result, original_formatted_text, user_formatted_text, user_text, error){
	var log = new Object();

	log.action = "parsing";

	if(parsing_result!='' && parsing_result != undefined && parsing_result != 'undefined'){
    	log.parsing_result = parsing_result;
    }
    if(original_formatted_text!='' && original_formatted_text != undefined && original_formatted_text != 'undefined'){
    	log.original_formatted_text = original_formatted_text;
    }
    if(user_formatted_text!='' && user_formatted_text != undefined && user_formatted_text != 'undefined'){
    	log.user_formatted_text = user_formatted_text;
    }
    if(user_text!='' && user_text != undefined && user_text != 'undefined'){
    	log.user_text = user_text;
    }
	if(error!='' && error != undefined && error != 'undefined'){
    	log.error = error;
    }

    var json_data = JSON.stringify(log);
}
